# nng_mtx_alloc(3supp) Manual Page

## NAME

nng_mtx_alloc - allocate mutex

## SYNOPSIS

    #include <nng/nng.h>
    #include <nng/supplemental/util/platform.h>

    typedef struct nng_mtx nng_mtx;

    int nng_mtx_alloc(nng_mtx **mtxp);

## DESCRIPTION

The `nng_mtx_alloc()` function allocates mutex and returns it in mtxp.

The mutex objects created by this function are suitable only for simple lock and unlock operations, and are not recursive. Every effort has been made to use light-weight underlying primitives when available.

Mutex (mutual exclusion) objects can be thought of as binary semaphores, where only a single thread of execution is permitted to acquire the semaphore.

Furthermore, a mutex can only be unlocked by the thread that locked it.

## RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

## ERRORS

`NNG_ENOMEM` | Insufficient free memory exists.

## SEE ALSO

nng_cv_alloc(3supp), nng_mtx_free(3supp), nng_mtx_lock(3supp), nng_mtx_unlock(3supp), nng_strerror(3), nng(7)